/*
 * string.h
 *
 * Definitions for memory and string functions.
 */

#ifndef _xSTRING_H_
#define	_xSTRING_H_
# define PSTR(s) ((const PROGMEM char *)(s))

#define strncasecmp_P strncasecmp
#define strcasestr_P strcasestr
#define strcpy_P strcpy
//==================================================
//#define pgm_read_byte(address_short) ((uint8_t)(address_short))


char pgm_read_bytex(uint8_t *x){
return *x;
}


int
strncasecmp(s1, s2, n)
	const char *s1, *s2;
	size_t n;
{
	if (n != 0) {
		const uint8_t
				*us1 = (const uint8_t *)s1,
				*us2 = (const uint8_t *)s2;

		do {
			if (tolower(*us1) != tolower(*us2++))
				return (tolower(*us1) - tolower(*--us2));
			if (*us1++ == '\0')
				break;
		} while (--n != 0);
	}
	return (0);
}
//==================================================
char *
strcasestr(s, find)
	const char *s, *find;
{
	char c, sc;
	size_t len;

	if ((c = *find++) != 0) {
		c = tolower((unsigned char)c);
		len = strlen(find);
		do {
			do {
				if ((sc = *s++) == 0)
					return (NULL);
			} while ((char)tolower((unsigned char)sc) != c);
		} while (strncasecmp(s, find, len) != 0);
		s--;
	}
	return ((char *)s);
}
//=============================================
size_t
strlen(str)
	const char *str;
{
	const char *s;

	for (s = str; *s; ++s);
	return(s - str);
}
//=============================================
////strnlen (strlen (s) < maxlen ? strlen (s) : maxlen)
size_t
strnlen(const char *str,char maxlen){
	const char *s;
	char zl=0;
	for (s = str; *s; ++s){zl++;}//???
if (maxlen>zl)	//??????????????
	return(s - str);
else
	return(maxlen);//?????
}
//=============================================

_
#endif /* _STRING_H_ */
