/*----------------------------------------------------------------------------
 Copyright:      Dietmar Misch
 Author:         Dietmar Misch
 ---------------------------------------------------------------------------*/
#if usart_udp
#define UDP_DEBUG usart_write
#else
#define UDP_DEBUG(...)
#endif

//	#include <config.h>
#define USE_UDP_SEND 1
#if USE_UDP_SEND
/*	#include <avr/io.h>
	#include "stack.h"
	#include "usart.h"
	#include "httpd.h"*/
	
//----------------------------------------------------------------------------
//Empfang der Daten von einem UDP Server Port
void udp_empfang_port85 (unsigned char index){
	uint16_t var=0;
	uint8_t kkudp[(UDP_DATA_END_VAR)-(UDP_DATA_START)];
	memcpy (kkudp,&eth_buffer[42],(UDP_DATA_END_VAR)-(UDP_DATA_START));
	lgw(3,1,kkudp);
}
//Initialisierung des UDP Ports (f�r Daten empfang)
void udp_init (void){
	lgw(2,1,"UDP init done");
	//Port in Anwendungstabelle eintragen f�r eingehende NTP Daten!
	add_udp_app (UDP_EMPFANGS_PORT, (void(*)(unsigned char))udp_empfang_port85);
}
//----------------------------------------------------------------------------
//####################################################################################*/
//Ergänzung kk
void arp_requestx( uint8_t ip4dest){
//char testv[42]=arp_request_segment;
char testv[42]={eth_segment,arp_segment};
testv[13]=6;//typ 0x0806
testv[41]=(ip4dest);
networkdevice_send(testv,42);
}
//----------------------------------------------------------------------------
//Senden der aktuellen Daten zu einen UDP Server
#define MAX_VAR_ARRAY 10
void xudp_send (uint8_t UDP_IP4_SEND){
uint32_t UDP_IP_SEND=(MYIP_1<<24|MYIP_2<<16|MYIP_3<<8|UDP_IP4_SEND);
#if (UDP_SENDE_PORT!=0)
  uint16_t byte_count,var=0;
  uint8_t var_array[MAX_VAR_ARRAY]={'k','k','t','e','s','t'};


//oeffnet eine Verbindung zu einem UDP Server
  //ARP Request senden
var=  arp_request(124);

//wenn erfolgreich udp-paket senden
if (var == 1)
  {
    for (byte_count = 0;byte_count<(MAX_VAR_ARRAY);byte_count=byte_count+1)
    {
      eth_buffer[UDP_DATA_START + byte_count]   = (unsigned char)var_array[var];
 //     eth_buffer[UDP_DATA_START + byte_count+1] = (unsigned char)((var_array[var]) >> 8);
      var++;
    }
    create_new_udp_packet(byte_count,UDP_EMPFANGS_PORT,UDP_SENDE_PORT,ip_aus_ip4_x(124));
    UDP_DEBUG("** UDP Daten gesendet! **\r\n");
    return;
  }
  UDP_DEBUG("Kein UDP Server gefunden!!\r\n");
#endif
  return;
}
#endif //USE_UDP_SEND


